package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.UserOrder;
import com.izouma.awesomeadmin.service.UserOrderService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * controller类
 */
@Controller
@RequestMapping("/userOrder")
public class UserOrderController {

    @Autowired
    private UserOrderService userOrderService;

    /**
     * <p>获取全部记录。</p>
     */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(UserOrder record) {
        List<UserOrder> pp = userOrderService.getUserOrderList(record);
        return new Result(true, pp);
    }

    /**
     * <p>根据Id。</p>
     */
    @RequestMapping(value = "/getUserOrder", method = RequestMethod.GET)
    @ResponseBody
    public Result getUserOrder(@RequestParam(required = false, value = "id") String id) {
        UserOrder data = userOrderService.getUserOrderById(id);
        return new Result(true, data);
    }

    /**
     * <p>根据条件获取。</p>
     */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(UserOrder record) {
        UserOrder data = userOrderService.getUserOrder(record);
        return new Result(true, data);
    }


    /**
     * <p>分页查询。</p>
     */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, UserOrder record) {
        Map<String, Object> result = new HashMap<>();

        List<UserOrder> pp = userOrderService.getUserOrderByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
     * <p>保存。</p>
     */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(UserOrder record) {
        return userOrderService.createUserOrder(record);
    }

    /**
     * <p>更新信息。</p>
     */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateUserOrder(UserOrder record) {
        boolean num = userOrderService.updateUserOrder(record);
        if (num) {
            return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>删除。</p>
     */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteUserOrder(UserOrder record) {

        boolean num = userOrderService.deleteUserOrder(record);
        if (num) {
            return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
     * 导出Excel
     *
     * @param request
     * @param response
     * @param record
     * @throws Exception
     */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, UserOrder record) throws Exception {

        List<UserOrder> userOrders = userOrderService.getUserOrderList(record);


        String sheetName = "user_order";
        String titleName = "用户订单数据表";
        String fileName = "用户订单表";
        int columnNumber = 19;
        int[] columnWidth = {20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20};
        String[] columnName = {"ID", "删除标识", "更新时间", "更新人", "创建时间", "创建人", "用户ID", "地标ID", "导游包ID", "状态", "支付时间", "支付方式", "备注", "显示标识", "金额", "现金", "积分", "成交", "推广码"};
        String[][] dataList = new String[userOrders.size()][19];

        for (int i = 0; i < userOrders.size(); i++) {

            dataList[i][0] = String.valueOf(userOrders.get(i).getId());
            dataList[i][1] = String.valueOf(userOrders.get(i).getDelFlag());
            dataList[i][2] = String.valueOf(userOrders.get(i).getUpdateTime());
            dataList[i][3] = String.valueOf(userOrders.get(i).getUpdateUser());
            dataList[i][4] = String.valueOf(userOrders.get(i).getCreateTime());
            dataList[i][5] = String.valueOf(userOrders.get(i).getCreateUser());
            dataList[i][6] = String.valueOf(userOrders.get(i).getUserId());
            dataList[i][7] = String.valueOf(userOrders.get(i).getLankMarkId());
            dataList[i][8] = String.valueOf(userOrders.get(i).getPackageId());
            dataList[i][9] = String.valueOf(userOrders.get(i).getStatusFlag());
            dataList[i][10] = String.valueOf(userOrders.get(i).getPayTime());
            dataList[i][11] = String.valueOf(userOrders.get(i).getPayMode());
            dataList[i][12] = String.valueOf(userOrders.get(i).getRemark());
            dataList[i][13] = String.valueOf(userOrders.get(i).getShowFlag());
            dataList[i][14] = String.valueOf(userOrders.get(i).getTotlePrice());
            dataList[i][15] = String.valueOf(userOrders.get(i).getCash());
            dataList[i][16] = String.valueOf(userOrders.get(i).getPoint());
            dataList[i][17] = String.valueOf(userOrders.get(i).getDealPrice());
            dataList[i][18] = String.valueOf(userOrders.get(i).getMarketCode());
        }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
                columnNumber, columnWidth, columnName, dataList, response);


    }


    @RequestMapping(value = "/pay", method = RequestMethod.POST)
    @ResponseBody
    public Result pay(@RequestParam(required = true, value = "orderId") String orderId, @RequestParam(required = true, value = "coin") double coin) {

        return userOrderService.payOrder(orderId, coin, 0, 0, AppConstant.PayMode.COIN);

    }

}

